(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
	typeof define === 'function' && define.amd ? define(['exports'], factory) :
	(global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.dataStructures = {}));
})(this, (function (exports) { 'use strict';

	var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

	function getDefaultExportFromCjs (x) {
		return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
	}

	var classCallCheck = {exports: {}};

	(function (module) {
		function _classCallCheck(instance, Constructor) {
		  if (!(instance instanceof Constructor)) {
		    throw new TypeError("Cannot call a class as a function");
		  }
		}

		module.exports = _classCallCheck, module.exports.__esModule = true, module.exports["default"] = module.exports;
	} (classCallCheck));

	var _classCallCheck = /*@__PURE__*/getDefaultExportFromCjs(classCallCheck.exports);

	var createClass = {exports: {}};

	var defineProperty$b = {exports: {}};

	var defineProperty$a = {exports: {}};

	var defineProperty$9 = {exports: {}};

	var check = function (it) {
	  return it && it.Math == Math && it;
	};

	// https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
	var global$k =
	  // eslint-disable-next-line es-x/no-global-this -- safe
	  check(typeof globalThis == 'object' && globalThis) ||
	  check(typeof window == 'object' && window) ||
	  // eslint-disable-next-line no-restricted-globals -- safe
	  check(typeof self == 'object' && self) ||
	  check(typeof commonjsGlobal == 'object' && commonjsGlobal) ||
	  // eslint-disable-next-line no-new-func -- fallback
	  (function () { return this; })() || Function('return this')();

	var fails$7 = function (exec) {
	  try {
	    return !!exec();
	  } catch (error) {
	    return true;
	  }
	};

	var fails$6 = fails$7;

	var functionBindNative = !fails$6(function () {
	  // eslint-disable-next-line es-x/no-function-prototype-bind -- safe
	  var test = (function () { /* empty */ }).bind();
	  // eslint-disable-next-line no-prototype-builtins -- safe
	  return typeof test != 'function' || test.hasOwnProperty('prototype');
	});

	var NATIVE_BIND$3 = functionBindNative;

	var FunctionPrototype$1 = Function.prototype;
	var apply$1 = FunctionPrototype$1.apply;
	var call$5 = FunctionPrototype$1.call;

	// eslint-disable-next-line es-x/no-reflect -- safe
	var functionApply = typeof Reflect == 'object' && Reflect.apply || (NATIVE_BIND$3 ? call$5.bind(apply$1) : function () {
	  return call$5.apply(apply$1, arguments);
	});

	var NATIVE_BIND$2 = functionBindNative;

	var FunctionPrototype = Function.prototype;
	var bind$2 = FunctionPrototype.bind;
	var call$4 = FunctionPrototype.call;
	var uncurryThis$7 = NATIVE_BIND$2 && bind$2.bind(call$4, call$4);

	var functionUncurryThis = NATIVE_BIND$2 ? function (fn) {
	  return fn && uncurryThis$7(fn);
	} : function (fn) {
	  return fn && function () {
	    return call$4.apply(fn, arguments);
	  };
	};

	// `IsCallable` abstract operation
	// https://tc39.es/ecma262/#sec-iscallable
	var isCallable$8 = function (argument) {
	  return typeof argument == 'function';
	};

	var objectGetOwnPropertyDescriptor = {};

	var fails$5 = fails$7;

	// Detect IE8's incomplete defineProperty implementation
	var descriptors = !fails$5(function () {
	  // eslint-disable-next-line es-x/no-object-defineproperty -- required for testing
	  return Object.defineProperty({}, 1, { get: function () { return 7; } })[1] != 7;
	});

	var NATIVE_BIND$1 = functionBindNative;

	var call$3 = Function.prototype.call;

	var functionCall = NATIVE_BIND$1 ? call$3.bind(call$3) : function () {
	  return call$3.apply(call$3, arguments);
	};

	var objectPropertyIsEnumerable = {};

	var $propertyIsEnumerable = {}.propertyIsEnumerable;
	// eslint-disable-next-line es-x/no-object-getownpropertydescriptor -- safe
	var getOwnPropertyDescriptor$1 = Object.getOwnPropertyDescriptor;

	// Nashorn ~ JDK8 bug
	var NASHORN_BUG = getOwnPropertyDescriptor$1 && !$propertyIsEnumerable.call({ 1: 2 }, 1);

	// `Object.prototype.propertyIsEnumerable` method implementation
	// https://tc39.es/ecma262/#sec-object.prototype.propertyisenumerable
	objectPropertyIsEnumerable.f = NASHORN_BUG ? function propertyIsEnumerable(V) {
	  var descriptor = getOwnPropertyDescriptor$1(this, V);
	  return !!descriptor && descriptor.enumerable;
	} : $propertyIsEnumerable;

	var createPropertyDescriptor$2 = function (bitmap, value) {
	  return {
	    enumerable: !(bitmap & 1),
	    configurable: !(bitmap & 2),
	    writable: !(bitmap & 4),
	    value: value
	  };
	};

	var uncurryThis$6 = functionUncurryThis;

	var toString$2 = uncurryThis$6({}.toString);
	var stringSlice = uncurryThis$6(''.slice);

	var classofRaw$1 = function (it) {
	  return stringSlice(toString$2(it), 8, -1);
	};

	var global$j = global$k;
	var uncurryThis$5 = functionUncurryThis;
	var fails$4 = fails$7;
	var classof$2 = classofRaw$1;

	var Object$5 = global$j.Object;
	var split = uncurryThis$5(''.split);

	// fallback for non-array-like ES3 and non-enumerable old V8 strings
	var indexedObject = fails$4(function () {
	  // throws an error in rhino, see https://github.com/mozilla/rhino/issues/346
	  // eslint-disable-next-line no-prototype-builtins -- safe
	  return !Object$5('z').propertyIsEnumerable(0);
	}) ? function (it) {
	  return classof$2(it) == 'String' ? split(it, '') : Object$5(it);
	} : Object$5;

	var global$i = global$k;

	var TypeError$6 = global$i.TypeError;

	// `RequireObjectCoercible` abstract operation
	// https://tc39.es/ecma262/#sec-requireobjectcoercible
	var requireObjectCoercible$2 = function (it) {
	  if (it == undefined) throw TypeError$6("Can't call method on " + it);
	  return it;
	};

	// toObject with fallback for non-array-like ES3 strings
	var IndexedObject = indexedObject;
	var requireObjectCoercible$1 = requireObjectCoercible$2;

	var toIndexedObject$1 = function (it) {
	  return IndexedObject(requireObjectCoercible$1(it));
	};

	var isCallable$7 = isCallable$8;

	var isObject$4 = function (it) {
	  return typeof it == 'object' ? it !== null : isCallable$7(it);
	};

	var path$4 = {};

	var path$3 = path$4;
	var global$h = global$k;
	var isCallable$6 = isCallable$8;

	var aFunction = function (variable) {
	  return isCallable$6(variable) ? variable : undefined;
	};

	var getBuiltIn$3 = function (namespace, method) {
	  return arguments.length < 2 ? aFunction(path$3[namespace]) || aFunction(global$h[namespace])
	    : path$3[namespace] && path$3[namespace][method] || global$h[namespace] && global$h[namespace][method];
	};

	var uncurryThis$4 = functionUncurryThis;

	var objectIsPrototypeOf = uncurryThis$4({}.isPrototypeOf);

	var getBuiltIn$2 = getBuiltIn$3;

	var engineUserAgent = getBuiltIn$2('navigator', 'userAgent') || '';

	var global$g = global$k;
	var userAgent = engineUserAgent;

	var process = global$g.process;
	var Deno = global$g.Deno;
	var versions = process && process.versions || Deno && Deno.version;
	var v8 = versions && versions.v8;
	var match, version;

	if (v8) {
	  match = v8.split('.');
	  // in old Chrome, versions of V8 isn't V8 = Chrome / 10
	  // but their correct versions are not interesting for us
	  version = match[0] > 0 && match[0] < 4 ? 1 : +(match[0] + match[1]);
	}

	// BrowserFS NodeJS `process` polyfill incorrectly set `.v8` to `0.0`
	// so check `userAgent` even if `.v8` exists, but 0
	if (!version && userAgent) {
	  match = userAgent.match(/Edge\/(\d+)/);
	  if (!match || match[1] >= 74) {
	    match = userAgent.match(/Chrome\/(\d+)/);
	    if (match) version = +match[1];
	  }
	}

	var engineV8Version = version;

	/* eslint-disable es-x/no-symbol -- required for testing */

	var V8_VERSION = engineV8Version;
	var fails$3 = fails$7;

	// eslint-disable-next-line es-x/no-object-getownpropertysymbols -- required for testing
	var nativeSymbol = !!Object.getOwnPropertySymbols && !fails$3(function () {
	  var symbol = Symbol();
	  // Chrome 38 Symbol has incorrect toString conversion
	  // `get-own-property-symbols` polyfill symbols converted to object are not Symbol instances
	  return !String(symbol) || !(Object(symbol) instanceof Symbol) ||
	    // Chrome 38-40 symbols are not inherited from DOM collections prototypes to instances
	    !Symbol.sham && V8_VERSION && V8_VERSION < 41;
	});

	/* eslint-disable es-x/no-symbol -- required for testing */

	var NATIVE_SYMBOL$1 = nativeSymbol;

	var useSymbolAsUid = NATIVE_SYMBOL$1
	  && !Symbol.sham
	  && typeof Symbol.iterator == 'symbol';

	var global$f = global$k;
	var getBuiltIn$1 = getBuiltIn$3;
	var isCallable$5 = isCallable$8;
	var isPrototypeOf = objectIsPrototypeOf;
	var USE_SYMBOL_AS_UID$1 = useSymbolAsUid;

	var Object$4 = global$f.Object;

	var isSymbol$2 = USE_SYMBOL_AS_UID$1 ? function (it) {
	  return typeof it == 'symbol';
	} : function (it) {
	  var $Symbol = getBuiltIn$1('Symbol');
	  return isCallable$5($Symbol) && isPrototypeOf($Symbol.prototype, Object$4(it));
	};

	var global$e = global$k;

	var String$2 = global$e.String;

	var tryToString$1 = function (argument) {
	  try {
	    return String$2(argument);
	  } catch (error) {
	    return 'Object';
	  }
	};

	var global$d = global$k;
	var isCallable$4 = isCallable$8;
	var tryToString = tryToString$1;

	var TypeError$5 = global$d.TypeError;

	// `Assert: IsCallable(argument) is true`
	var aCallable$2 = function (argument) {
	  if (isCallable$4(argument)) return argument;
	  throw TypeError$5(tryToString(argument) + ' is not a function');
	};

	var aCallable$1 = aCallable$2;

	// `GetMethod` abstract operation
	// https://tc39.es/ecma262/#sec-getmethod
	var getMethod$1 = function (V, P) {
	  var func = V[P];
	  return func == null ? undefined : aCallable$1(func);
	};

	var global$c = global$k;
	var call$2 = functionCall;
	var isCallable$3 = isCallable$8;
	var isObject$3 = isObject$4;

	var TypeError$4 = global$c.TypeError;

	// `OrdinaryToPrimitive` abstract operation
	// https://tc39.es/ecma262/#sec-ordinarytoprimitive
	var ordinaryToPrimitive$1 = function (input, pref) {
	  var fn, val;
	  if (pref === 'string' && isCallable$3(fn = input.toString) && !isObject$3(val = call$2(fn, input))) return val;
	  if (isCallable$3(fn = input.valueOf) && !isObject$3(val = call$2(fn, input))) return val;
	  if (pref !== 'string' && isCallable$3(fn = input.toString) && !isObject$3(val = call$2(fn, input))) return val;
	  throw TypeError$4("Can't convert object to primitive value");
	};

	var shared$1 = {exports: {}};

	var global$b = global$k;

	// eslint-disable-next-line es-x/no-object-defineproperty -- safe
	var defineProperty$8 = Object.defineProperty;

	var setGlobal$1 = function (key, value) {
	  try {
	    defineProperty$8(global$b, key, { value: value, configurable: true, writable: true });
	  } catch (error) {
	    global$b[key] = value;
	  } return value;
	};

	var global$a = global$k;
	var setGlobal = setGlobal$1;

	var SHARED = '__core-js_shared__';
	var store$1 = global$a[SHARED] || setGlobal(SHARED, {});

	var sharedStore = store$1;

	var store = sharedStore;

	(shared$1.exports = function (key, value) {
	  return store[key] || (store[key] = value !== undefined ? value : {});
	})('versions', []).push({
	  version: '3.22.5',
	  mode: 'pure' ,
	  copyright: '© 2014-2022 Denis Pushkarev (zloirock.ru)',
	  license: 'https://github.com/zloirock/core-js/blob/v3.22.5/LICENSE',
	  source: 'https://github.com/zloirock/core-js'
	});

	var global$9 = global$k;
	var requireObjectCoercible = requireObjectCoercible$2;

	var Object$3 = global$9.Object;

	// `ToObject` abstract operation
	// https://tc39.es/ecma262/#sec-toobject
	var toObject$1 = function (argument) {
	  return Object$3(requireObjectCoercible(argument));
	};

	var uncurryThis$3 = functionUncurryThis;
	var toObject = toObject$1;

	var hasOwnProperty = uncurryThis$3({}.hasOwnProperty);

	// `HasOwnProperty` abstract operation
	// https://tc39.es/ecma262/#sec-hasownproperty
	// eslint-disable-next-line es-x/no-object-hasown -- safe
	var hasOwnProperty_1 = Object.hasOwn || function hasOwn(it, key) {
	  return hasOwnProperty(toObject(it), key);
	};

	var uncurryThis$2 = functionUncurryThis;

	var id = 0;
	var postfix = Math.random();
	var toString$1 = uncurryThis$2(1.0.toString);

	var uid$1 = function (key) {
	  return 'Symbol(' + (key === undefined ? '' : key) + ')_' + toString$1(++id + postfix, 36);
	};

	var global$8 = global$k;
	var shared = shared$1.exports;
	var hasOwn$4 = hasOwnProperty_1;
	var uid = uid$1;
	var NATIVE_SYMBOL = nativeSymbol;
	var USE_SYMBOL_AS_UID = useSymbolAsUid;

	var WellKnownSymbolsStore = shared('wks');
	var Symbol$1 = global$8.Symbol;
	var symbolFor = Symbol$1 && Symbol$1['for'];
	var createWellKnownSymbol = USE_SYMBOL_AS_UID ? Symbol$1 : Symbol$1 && Symbol$1.withoutSetter || uid;

	var wellKnownSymbol$5 = function (name) {
	  if (!hasOwn$4(WellKnownSymbolsStore, name) || !(NATIVE_SYMBOL || typeof WellKnownSymbolsStore[name] == 'string')) {
	    var description = 'Symbol.' + name;
	    if (NATIVE_SYMBOL && hasOwn$4(Symbol$1, name)) {
	      WellKnownSymbolsStore[name] = Symbol$1[name];
	    } else if (USE_SYMBOL_AS_UID && symbolFor) {
	      WellKnownSymbolsStore[name] = symbolFor(description);
	    } else {
	      WellKnownSymbolsStore[name] = createWellKnownSymbol(description);
	    }
	  } return WellKnownSymbolsStore[name];
	};

	var global$7 = global$k;
	var call$1 = functionCall;
	var isObject$2 = isObject$4;
	var isSymbol$1 = isSymbol$2;
	var getMethod = getMethod$1;
	var ordinaryToPrimitive = ordinaryToPrimitive$1;
	var wellKnownSymbol$4 = wellKnownSymbol$5;

	var TypeError$3 = global$7.TypeError;
	var TO_PRIMITIVE = wellKnownSymbol$4('toPrimitive');

	// `ToPrimitive` abstract operation
	// https://tc39.es/ecma262/#sec-toprimitive
	var toPrimitive$1 = function (input, pref) {
	  if (!isObject$2(input) || isSymbol$1(input)) return input;
	  var exoticToPrim = getMethod(input, TO_PRIMITIVE);
	  var result;
	  if (exoticToPrim) {
	    if (pref === undefined) pref = 'default';
	    result = call$1(exoticToPrim, input, pref);
	    if (!isObject$2(result) || isSymbol$1(result)) return result;
	    throw TypeError$3("Can't convert object to primitive value");
	  }
	  if (pref === undefined) pref = 'number';
	  return ordinaryToPrimitive(input, pref);
	};

	var toPrimitive = toPrimitive$1;
	var isSymbol = isSymbol$2;

	// `ToPropertyKey` abstract operation
	// https://tc39.es/ecma262/#sec-topropertykey
	var toPropertyKey$2 = function (argument) {
	  var key = toPrimitive(argument, 'string');
	  return isSymbol(key) ? key : key + '';
	};

	var global$6 = global$k;
	var isObject$1 = isObject$4;

	var document = global$6.document;
	// typeof document.createElement is 'object' in old IE
	var EXISTS = isObject$1(document) && isObject$1(document.createElement);

	var documentCreateElement = function (it) {
	  return EXISTS ? document.createElement(it) : {};
	};

	var DESCRIPTORS$5 = descriptors;
	var fails$2 = fails$7;
	var createElement = documentCreateElement;

	// Thanks to IE8 for its funny defineProperty
	var ie8DomDefine = !DESCRIPTORS$5 && !fails$2(function () {
	  // eslint-disable-next-line es-x/no-object-defineproperty -- required for testing
	  return Object.defineProperty(createElement('div'), 'a', {
	    get: function () { return 7; }
	  }).a != 7;
	});

	var DESCRIPTORS$4 = descriptors;
	var call = functionCall;
	var propertyIsEnumerableModule = objectPropertyIsEnumerable;
	var createPropertyDescriptor$1 = createPropertyDescriptor$2;
	var toIndexedObject = toIndexedObject$1;
	var toPropertyKey$1 = toPropertyKey$2;
	var hasOwn$3 = hasOwnProperty_1;
	var IE8_DOM_DEFINE$1 = ie8DomDefine;

	// eslint-disable-next-line es-x/no-object-getownpropertydescriptor -- safe
	var $getOwnPropertyDescriptor$1 = Object.getOwnPropertyDescriptor;

	// `Object.getOwnPropertyDescriptor` method
	// https://tc39.es/ecma262/#sec-object.getownpropertydescriptor
	objectGetOwnPropertyDescriptor.f = DESCRIPTORS$4 ? $getOwnPropertyDescriptor$1 : function getOwnPropertyDescriptor(O, P) {
	  O = toIndexedObject(O);
	  P = toPropertyKey$1(P);
	  if (IE8_DOM_DEFINE$1) try {
	    return $getOwnPropertyDescriptor$1(O, P);
	  } catch (error) { /* empty */ }
	  if (hasOwn$3(O, P)) return createPropertyDescriptor$1(!call(propertyIsEnumerableModule.f, O, P), O[P]);
	};

	var fails$1 = fails$7;
	var isCallable$2 = isCallable$8;

	var replacement = /#|\.prototype\./;

	var isForced$1 = function (feature, detection) {
	  var value = data[normalize(feature)];
	  return value == POLYFILL ? true
	    : value == NATIVE ? false
	    : isCallable$2(detection) ? fails$1(detection)
	    : !!detection;
	};

	var normalize = isForced$1.normalize = function (string) {
	  return String(string).replace(replacement, '.').toLowerCase();
	};

	var data = isForced$1.data = {};
	var NATIVE = isForced$1.NATIVE = 'N';
	var POLYFILL = isForced$1.POLYFILL = 'P';

	var isForced_1 = isForced$1;

	var uncurryThis$1 = functionUncurryThis;
	var aCallable = aCallable$2;
	var NATIVE_BIND = functionBindNative;

	var bind$1 = uncurryThis$1(uncurryThis$1.bind);

	// optional / simple context binding
	var functionBindContext = function (fn, that) {
	  aCallable(fn);
	  return that === undefined ? fn : NATIVE_BIND ? bind$1(fn, that) : function (/* ...args */) {
	    return fn.apply(that, arguments);
	  };
	};

	var objectDefineProperty = {};

	var DESCRIPTORS$3 = descriptors;
	var fails = fails$7;

	// V8 ~ Chrome 36-
	// https://bugs.chromium.org/p/v8/issues/detail?id=3334
	var v8PrototypeDefineBug = DESCRIPTORS$3 && fails(function () {
	  // eslint-disable-next-line es-x/no-object-defineproperty -- required for testing
	  return Object.defineProperty(function () { /* empty */ }, 'prototype', {
	    value: 42,
	    writable: false
	  }).prototype != 42;
	});

	var global$5 = global$k;
	var isObject = isObject$4;

	var String$1 = global$5.String;
	var TypeError$2 = global$5.TypeError;

	// `Assert: Type(argument) is Object`
	var anObject$1 = function (argument) {
	  if (isObject(argument)) return argument;
	  throw TypeError$2(String$1(argument) + ' is not an object');
	};

	var global$4 = global$k;
	var DESCRIPTORS$2 = descriptors;
	var IE8_DOM_DEFINE = ie8DomDefine;
	var V8_PROTOTYPE_DEFINE_BUG = v8PrototypeDefineBug;
	var anObject = anObject$1;
	var toPropertyKey = toPropertyKey$2;

	var TypeError$1 = global$4.TypeError;
	// eslint-disable-next-line es-x/no-object-defineproperty -- safe
	var $defineProperty = Object.defineProperty;
	// eslint-disable-next-line es-x/no-object-getownpropertydescriptor -- safe
	var $getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
	var ENUMERABLE = 'enumerable';
	var CONFIGURABLE = 'configurable';
	var WRITABLE = 'writable';

	// `Object.defineProperty` method
	// https://tc39.es/ecma262/#sec-object.defineproperty
	objectDefineProperty.f = DESCRIPTORS$2 ? V8_PROTOTYPE_DEFINE_BUG ? function defineProperty(O, P, Attributes) {
	  anObject(O);
	  P = toPropertyKey(P);
	  anObject(Attributes);
	  if (typeof O === 'function' && P === 'prototype' && 'value' in Attributes && WRITABLE in Attributes && !Attributes[WRITABLE]) {
	    var current = $getOwnPropertyDescriptor(O, P);
	    if (current && current[WRITABLE]) {
	      O[P] = Attributes.value;
	      Attributes = {
	        configurable: CONFIGURABLE in Attributes ? Attributes[CONFIGURABLE] : current[CONFIGURABLE],
	        enumerable: ENUMERABLE in Attributes ? Attributes[ENUMERABLE] : current[ENUMERABLE],
	        writable: false
	      };
	    }
	  } return $defineProperty(O, P, Attributes);
	} : $defineProperty : function defineProperty(O, P, Attributes) {
	  anObject(O);
	  P = toPropertyKey(P);
	  anObject(Attributes);
	  if (IE8_DOM_DEFINE) try {
	    return $defineProperty(O, P, Attributes);
	  } catch (error) { /* empty */ }
	  if ('get' in Attributes || 'set' in Attributes) throw TypeError$1('Accessors not supported');
	  if ('value' in Attributes) O[P] = Attributes.value;
	  return O;
	};

	var DESCRIPTORS$1 = descriptors;
	var definePropertyModule = objectDefineProperty;
	var createPropertyDescriptor = createPropertyDescriptor$2;

	var createNonEnumerableProperty$2 = DESCRIPTORS$1 ? function (object, key, value) {
	  return definePropertyModule.f(object, key, createPropertyDescriptor(1, value));
	} : function (object, key, value) {
	  object[key] = value;
	  return object;
	};

	var global$3 = global$k;
	var apply = functionApply;
	var uncurryThis = functionUncurryThis;
	var isCallable$1 = isCallable$8;
	var getOwnPropertyDescriptor = objectGetOwnPropertyDescriptor.f;
	var isForced = isForced_1;
	var path$2 = path$4;
	var bind = functionBindContext;
	var createNonEnumerableProperty$1 = createNonEnumerableProperty$2;
	var hasOwn$2 = hasOwnProperty_1;

	var wrapConstructor = function (NativeConstructor) {
	  var Wrapper = function (a, b, c) {
	    if (this instanceof Wrapper) {
	      switch (arguments.length) {
	        case 0: return new NativeConstructor();
	        case 1: return new NativeConstructor(a);
	        case 2: return new NativeConstructor(a, b);
	      } return new NativeConstructor(a, b, c);
	    } return apply(NativeConstructor, this, arguments);
	  };
	  Wrapper.prototype = NativeConstructor.prototype;
	  return Wrapper;
	};

	/*
	  options.target      - name of the target object
	  options.global      - target is the global object
	  options.stat        - export as static methods of target
	  options.proto       - export as prototype methods of target
	  options.real        - real prototype method for the `pure` version
	  options.forced      - export even if the native feature is available
	  options.bind        - bind methods to the target, required for the `pure` version
	  options.wrap        - wrap constructors to preventing global pollution, required for the `pure` version
	  options.unsafe      - use the simple assignment of property instead of delete + defineProperty
	  options.sham        - add a flag to not completely full polyfills
	  options.enumerable  - export as enumerable property
	  options.noTargetGet - prevent calling a getter on target
	  options.name        - the .name of the function if it does not match the key
	*/
	var _export = function (options, source) {
	  var TARGET = options.target;
	  var GLOBAL = options.global;
	  var STATIC = options.stat;
	  var PROTO = options.proto;

	  var nativeSource = GLOBAL ? global$3 : STATIC ? global$3[TARGET] : (global$3[TARGET] || {}).prototype;

	  var target = GLOBAL ? path$2 : path$2[TARGET] || createNonEnumerableProperty$1(path$2, TARGET, {})[TARGET];
	  var targetPrototype = target.prototype;

	  var FORCED, USE_NATIVE, VIRTUAL_PROTOTYPE;
	  var key, sourceProperty, targetProperty, nativeProperty, resultProperty, descriptor;

	  for (key in source) {
	    FORCED = isForced(GLOBAL ? key : TARGET + (STATIC ? '.' : '#') + key, options.forced);
	    // contains in native
	    USE_NATIVE = !FORCED && nativeSource && hasOwn$2(nativeSource, key);

	    targetProperty = target[key];

	    if (USE_NATIVE) if (options.noTargetGet) {
	      descriptor = getOwnPropertyDescriptor(nativeSource, key);
	      nativeProperty = descriptor && descriptor.value;
	    } else nativeProperty = nativeSource[key];

	    // export native or implementation
	    sourceProperty = (USE_NATIVE && nativeProperty) ? nativeProperty : source[key];

	    if (USE_NATIVE && typeof targetProperty == typeof sourceProperty) continue;

	    // bind timers to global for call from export context
	    if (options.bind && USE_NATIVE) resultProperty = bind(sourceProperty, global$3);
	    // wrap global constructors for prevent changs in this version
	    else if (options.wrap && USE_NATIVE) resultProperty = wrapConstructor(sourceProperty);
	    // make static versions for prototype methods
	    else if (PROTO && isCallable$1(sourceProperty)) resultProperty = uncurryThis(sourceProperty);
	    // default case
	    else resultProperty = sourceProperty;

	    // add a flag to not completely full polyfills
	    if (options.sham || (sourceProperty && sourceProperty.sham) || (targetProperty && targetProperty.sham)) {
	      createNonEnumerableProperty$1(resultProperty, 'sham', true);
	    }

	    createNonEnumerableProperty$1(target, key, resultProperty);

	    if (PROTO) {
	      VIRTUAL_PROTOTYPE = TARGET + 'Prototype';
	      if (!hasOwn$2(path$2, VIRTUAL_PROTOTYPE)) {
	        createNonEnumerableProperty$1(path$2, VIRTUAL_PROTOTYPE, {});
	      }
	      // export virtual prototype methods
	      createNonEnumerableProperty$1(path$2[VIRTUAL_PROTOTYPE], key, sourceProperty);
	      // export real prototype methods
	      if (options.real && targetPrototype && !targetPrototype[key]) {
	        createNonEnumerableProperty$1(targetPrototype, key, sourceProperty);
	      }
	    }
	  }
	};

	var $ = _export;
	var DESCRIPTORS = descriptors;
	var defineProperty$7 = objectDefineProperty.f;

	// `Object.defineProperty` method
	// https://tc39.es/ecma262/#sec-object.defineproperty
	// eslint-disable-next-line es-x/no-object-defineproperty -- safe
	$({ target: 'Object', stat: true, forced: Object.defineProperty !== defineProperty$7, sham: !DESCRIPTORS }, {
	  defineProperty: defineProperty$7
	});

	var path$1 = path$4;

	var Object$2 = path$1.Object;

	var defineProperty$6 = defineProperty$9.exports = function defineProperty(it, key, desc) {
	  return Object$2.defineProperty(it, key, desc);
	};

	if (Object$2.defineProperty.sham) defineProperty$6.sham = true;

	var parent$5 = defineProperty$9.exports;

	var defineProperty$5 = parent$5;

	var parent$4 = defineProperty$5;

	var defineProperty$4 = parent$4;

	var parent$3 = defineProperty$4;

	var defineProperty$3 = parent$3;

	(function (module) {
		module.exports = defineProperty$3;
	} (defineProperty$a));

	(function (module) {
		module.exports = defineProperty$a.exports;
	} (defineProperty$b));

	var _Object$defineProperty = /*@__PURE__*/getDefaultExportFromCjs(defineProperty$b.exports);

	(function (module) {
		var _Object$defineProperty = defineProperty$b.exports;

		function _defineProperties(target, props) {
		  for (var i = 0; i < props.length; i++) {
		    var descriptor = props[i];
		    descriptor.enumerable = descriptor.enumerable || false;
		    descriptor.configurable = true;
		    if ("value" in descriptor) descriptor.writable = true;

		    _Object$defineProperty(target, descriptor.key, descriptor);
		  }
		}

		function _createClass(Constructor, protoProps, staticProps) {
		  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
		  if (staticProps) _defineProperties(Constructor, staticProps);

		  _Object$defineProperty(Constructor, "prototype", {
		    writable: false
		  });

		  return Constructor;
		}

		module.exports = _createClass, module.exports.__esModule = true, module.exports["default"] = module.exports;
	} (createClass));

	var _createClass = /*@__PURE__*/getDefaultExportFromCjs(createClass.exports);

	var defineProperty$2 = {exports: {}};

	(function (module) {
		var _Object$defineProperty = defineProperty$b.exports;

		function _defineProperty(obj, key, value) {
		  if (key in obj) {
		    _Object$defineProperty(obj, key, {
		      value: value,
		      enumerable: true,
		      configurable: true,
		      writable: true
		    });
		  } else {
		    obj[key] = value;
		  }

		  return obj;
		}

		module.exports = _defineProperty, module.exports.__esModule = true, module.exports["default"] = module.exports;
	} (defineProperty$2));

	var _defineProperty = /*@__PURE__*/getDefaultExportFromCjs(defineProperty$2.exports);

	var toStringTag$5 = {exports: {}};

	var toStringTag$4 = {exports: {}};

	var wellKnownSymbol$3 = wellKnownSymbol$5;

	var TO_STRING_TAG$2 = wellKnownSymbol$3('toStringTag');
	var test = {};

	test[TO_STRING_TAG$2] = 'z';

	var toStringTagSupport = String(test) === '[object z]';

	var global$2 = global$k;
	var TO_STRING_TAG_SUPPORT$2 = toStringTagSupport;
	var isCallable = isCallable$8;
	var classofRaw = classofRaw$1;
	var wellKnownSymbol$2 = wellKnownSymbol$5;

	var TO_STRING_TAG$1 = wellKnownSymbol$2('toStringTag');
	var Object$1 = global$2.Object;

	// ES3 wrong here
	var CORRECT_ARGUMENTS = classofRaw(function () { return arguments; }()) == 'Arguments';

	// fallback for IE11 Script Access Denied error
	var tryGet = function (it, key) {
	  try {
	    return it[key];
	  } catch (error) { /* empty */ }
	};

	// getting tag from ES6+ `Object.prototype.toString`
	var classof$1 = TO_STRING_TAG_SUPPORT$2 ? classofRaw : function (it) {
	  var O, tag, result;
	  return it === undefined ? 'Undefined' : it === null ? 'Null'
	    // @@toStringTag case
	    : typeof (tag = tryGet(O = Object$1(it), TO_STRING_TAG$1)) == 'string' ? tag
	    // builtinTag case
	    : CORRECT_ARGUMENTS ? classofRaw(O)
	    // ES3 arguments fallback
	    : (result = classofRaw(O)) == 'Object' && isCallable(O.callee) ? 'Arguments' : result;
	};

	var TO_STRING_TAG_SUPPORT$1 = toStringTagSupport;
	var classof = classof$1;

	// `Object.prototype.toString` method implementation
	// https://tc39.es/ecma262/#sec-object.prototype.tostring
	var objectToString = TO_STRING_TAG_SUPPORT$1 ? {}.toString : function toString() {
	  return '[object ' + classof(this) + ']';
	};

	var TO_STRING_TAG_SUPPORT = toStringTagSupport;
	var defineProperty$1 = objectDefineProperty.f;
	var createNonEnumerableProperty = createNonEnumerableProperty$2;
	var hasOwn$1 = hasOwnProperty_1;
	var toString = objectToString;
	var wellKnownSymbol$1 = wellKnownSymbol$5;

	var TO_STRING_TAG = wellKnownSymbol$1('toStringTag');

	var setToStringTag$2 = function (it, TAG, STATIC, SET_METHOD) {
	  if (it) {
	    var target = STATIC ? it : it.prototype;
	    if (!hasOwn$1(target, TO_STRING_TAG)) {
	      defineProperty$1(target, TO_STRING_TAG, { configurable: true, value: TAG });
	    }
	    if (SET_METHOD && !TO_STRING_TAG_SUPPORT) {
	      createNonEnumerableProperty(target, 'toString', toString);
	    }
	  }
	};

	var global$1 = global$k;
	var setToStringTag$1 = setToStringTag$2;

	// JSON[@@toStringTag] property
	// https://tc39.es/ecma262/#sec-json-@@tostringtag
	setToStringTag$1(global$1.JSON, 'JSON', true);

	var wellKnownSymbolWrapped = {};

	var wellKnownSymbol = wellKnownSymbol$5;

	wellKnownSymbolWrapped.f = wellKnownSymbol;

	var path = path$4;
	var hasOwn = hasOwnProperty_1;
	var wrappedWellKnownSymbolModule = wellKnownSymbolWrapped;
	var defineProperty = objectDefineProperty.f;

	var defineWellKnownSymbol$1 = function (NAME) {
	  var Symbol = path.Symbol || (path.Symbol = {});
	  if (!hasOwn(Symbol, NAME)) defineProperty(Symbol, NAME, {
	    value: wrappedWellKnownSymbolModule.f(NAME)
	  });
	};

	var getBuiltIn = getBuiltIn$3;
	var defineWellKnownSymbol = defineWellKnownSymbol$1;
	var setToStringTag = setToStringTag$2;

	// `Symbol.toStringTag` well-known symbol
	// https://tc39.es/ecma262/#sec-symbol.tostringtag
	defineWellKnownSymbol('toStringTag');

	// `Symbol.prototype[@@toStringTag]` property
	// https://tc39.es/ecma262/#sec-symbol.prototype-@@tostringtag
	setToStringTag(getBuiltIn('Symbol'), 'Symbol');

	var WrappedWellKnownSymbolModule = wellKnownSymbolWrapped;

	var toStringTag$3 = WrappedWellKnownSymbolModule.f('toStringTag');

	var parent$2 = toStringTag$3;

	var toStringTag$2 = parent$2;

	var parent$1 = toStringTag$2;

	var toStringTag$1 = parent$1;

	var parent = toStringTag$1;

	var toStringTag = parent;

	(function (module) {
		module.exports = toStringTag;
	} (toStringTag$4));

	(function (module) {
		module.exports = toStringTag$4.exports;
	} (toStringTag$5));

	var _Symbol$toStringTag3 = /*@__PURE__*/getDefaultExportFromCjs(toStringTag$5.exports);

	var _Symbol$toStringTag$2;
	_Symbol$toStringTag$2 = _Symbol$toStringTag3;
	var Stack = /*#__PURE__*/function () {
	  function Stack() {
	    var items = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

	    _classCallCheck(this, Stack);

	    _defineProperty(this, "_items", void 0);

	    _Object$defineProperty(this, "_items", {
	      enumerable: false,
	      configurable: false,
	      writable: false,
	      value: items
	    });
	  }

	  _createClass(Stack, [{
	    key: _Symbol$toStringTag$2,
	    get: function get() {
	      return "Stack";
	    } //添加一个新元素到栈顶

	  }, {
	    key: "push",
	    value: function push(element) {
	      this._items.unshift(element);
	    } //移除栈顶元素

	  }, {
	    key: "pop",
	    value: function pop() {
	      return this._items.shift();
	    } //返回栈顶元素

	  }, {
	    key: "peek",
	    value: function peek() {
	      return this._items[0];
	    } //如果栈里没有任何元素就返回true，否则返回false

	  }, {
	    key: "isEmpty",
	    value: function isEmpty() {
	      return this._items.length === 0;
	    } //返回栈里元素个数，类似数组的length

	  }, {
	    key: "size",
	    get: function get() {
	      return this._items.length;
	    } //将栈结构的内容以字符串的形式返回

	  }, {
	    key: "toString",
	    value: function toString() {
	      return this._items.toString();
	    }
	  }]);

	  return Stack;
	}();

	var _Symbol$toStringTag$1;
	_Symbol$toStringTag$1 = _Symbol$toStringTag3;
	var Queue = /*#__PURE__*/function () {
	  function Queue() {
	    var items = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

	    _classCallCheck(this, Queue);

	    _defineProperty(this, "_items", void 0);

	    _Object$defineProperty(this, "_items", {
	      enumerable: false,
	      configurable: false,
	      writable: false,
	      value: items
	    });
	  }

	  _createClass(Queue, [{
	    key: _Symbol$toStringTag$1,
	    get: function get() {
	      return "Queue";
	    } // 向队列尾部添加一个或多个新的项

	  }, {
	    key: "enqueue",
	    value: function enqueue() {
	      var _this$_items;

	      (_this$_items = this._items).push.apply(_this$_items, arguments);
	    } // 移除队列的第一个项（最前面），并返回被移除的元素

	  }, {
	    key: "dequeue",
	    value: function dequeue() {
	      return this._items.shift();
	    } // 返回队列中第一个元素——最先被添加的项,不改变队列，，类似栈的peek

	  }, {
	    key: "front",
	    value: function front() {
	      return this._items[0];
	    } //  如果队列中不包含任何元素，返回true

	  }, {
	    key: "isEmpty",
	    value: function isEmpty() {
	      return this._items.length === 0;
	    } // 返回队列元素个数

	  }, {
	    key: "size",
	    get: function get() {
	      return this._items.length;
	    } // 将队列中的内容转成字符串形式

	  }, {
	    key: "toString",
	    value: function toString() {
	      return this._items.join(" ");
	    }
	  }]);

	  return Queue;
	}();

	var _Symbol$toStringTag, _Symbol$toStringTag2;
	_Symbol$toStringTag = _Symbol$toStringTag3;

	var NodeItem = /*#__PURE__*/function () {
	  function NodeItem(data) {
	    _classCallCheck(this, NodeItem);

	    _defineProperty(this, "data", void 0);

	    _defineProperty(this, "next", void 0);

	    this.data = data;
	    this.next = null;
	  }

	  _createClass(NodeItem, [{
	    key: _Symbol$toStringTag,
	    get: function get() {
	      return "NodeItem";
	    }
	  }]);

	  return NodeItem;
	}();

	_Symbol$toStringTag2 = _Symbol$toStringTag3;
	var LinkedList = /*#__PURE__*/function () {
	  function LinkedList() {
	    _classCallCheck(this, LinkedList);

	    _defineProperty(this, "head", void 0);

	    this.head = null;
	  }

	  _createClass(LinkedList, [{
	    key: _Symbol$toStringTag2,
	    get: function get() {
	      return "LinkedList";
	    }
	    /**
	     * 获取链表节点个数
	     */

	  }, {
	    key: "size",
	    get: function get() {
	      var count = 0;
	      var current = this.head;
	      if (this.head === null) return 0;

	      while (current) {
	        count++;
	        current = current.next;
	      }

	      return count;
	    }
	    /**
	     * 判断是否为空链表
	     */

	  }, {
	    key: "isEmpty",
	    get: function get() {
	      return this.size === 0;
	    }
	    /**
	     * 指定位置插入节点
	     * @param item 节点
	     * @param index 节点位置
	     */

	  }, {
	    key: "insert",
	    value: function insert(item) {
	      var index = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.size;
	      this.judgedIndex(index);
	      var nodeItem = new NodeItem(item);

	      if (index === 0) {
	        var _this$head;

	        var next = ((_this$head = this.head) === null || _this$head === void 0 ? void 0 : _this$head.next) || null;
	        this.head = nodeItem;
	        nodeItem.next = next;
	      } else {
	        var _prev$next;

	        var prev = this.getPreviousItem(index);
	        nodeItem.next = ((_prev$next = prev.next) === null || _prev$next === void 0 ? void 0 : _prev$next.next) || null;
	        prev.next = nodeItem;
	      }
	    }
	    /**
	     * 更新指定位置的节点
	     * @param item 节点
	     * @param index 节点位置
	     */

	  }, {
	    key: "update",
	    value: function update(item, index) {
	      var nodeItem = this.findNodeItem(index);

	      if (nodeItem) {
	        nodeItem.data = item;
	        return nodeItem.data;
	      } else {
	        throw new Error("update failed, there is no node at this location ");
	      }
	    }
	    /**
	     * 获取指定位置的节点数据
	     * @param index 节点位置
	     */

	  }, {
	    key: "find",
	    value: function find(index) {
	      var nodeItem = this.findNodeItem(index);
	      return nodeItem === null || nodeItem === void 0 ? void 0 : nodeItem.data;
	    }
	    /**
	     * 删除指定位置的节点
	     * @param index 节点位置
	     */

	  }, {
	    key: "removeAt",
	    value: function removeAt(index) {
	      this.judgedIndex(index);
	      var nodeItem = this.findNodeItem(index);

	      if (nodeItem) {
	        if (index === 0) {
	          this.head = nodeItem.next;
	          return nodeItem.data;
	        }

	        var prevItem = this.getPreviousItem(index);
	        prevItem.next = nodeItem.next;
	      }
	    }
	    /**
	     * 删除链表中满足提供的测试函数的第一个节点
	     * @param fn
	     */

	  }, {
	    key: "remove",
	    value: function remove(fn) {
	      var currentNode = this.head;
	      var currentIndex = 0;

	      while (currentNode) {
	        if (fn(currentNode)) {
	          var prevNode = this.getPreviousItem(currentIndex);
	          prevNode.next = currentNode.next;
	          return currentNode.data;
	        }

	        currentIndex++;
	        currentNode = currentNode.next;
	      }
	    }
	    /**
	     * 获取指定位置的节点
	     * @param index 节点位置
	     */

	  }, {
	    key: "findNodeItem",
	    value: function findNodeItem(index) {
	      var currentIndex = 0;
	      var current = this.head;

	      while (current) {
	        if (currentIndex === index) {
	          return current;
	        }

	        current = current.next;
	        currentIndex++;
	      }
	    }
	    /**
	     * 判断输入的index是否合法
	     * @param index 索引
	     */

	  }, {
	    key: "judgedIndex",
	    value: function judgedIndex(index) {
	      if (index < 0 || index > this.size) {
	        throw new Error("index must be a non-negative number no greater than length! at judgedIndex(".concat(index, ")"));
	      }
	    }
	    /**
	     * 获得当前位置前一个节点（index不为0）
	     * @param index 索引
	     */

	  }, {
	    key: "getPreviousItem",
	    value: function getPreviousItem(index) {
	      if (index === 0) throw new Error("The first node has no previous node at getPreviousItem");
	      var current = this.head;
	      var currentIndex = 0;

	      while (current) {
	        if (currentIndex === index - 1) {
	          break;
	        }

	        current = current.next;
	        currentIndex++;
	      }

	      return current;
	    }
	  }]);

	  return LinkedList;
	}();

	exports.LinkedList = LinkedList;
	exports.Queue = Queue;
	exports.Stack = Stack;

	Object.defineProperty(exports, '__esModule', { value: true });

}));
